package sita;
import java.awt.Color;
import javax.swing.ActionMap;
import javax.swing.InputMap;
import javax.swing.KeyStroke;

// Implemented by class Main
public interface Annotated
{
    public void updateTitle();
    public void setColor(Color c);
    public Color getColor();
    public String getComment();
    public void refreshManuscript();
    public void refreshManuscript(boolean adjustScrolling);
    public int getDefaultDisplayWidth();
    public void setupInputActions(InputMap im, ActionMap am);
    public KeyStroke getAccelerator(String key);
    public boolean allowModification();
    public void debug(String s);
    public void debugAppend(String s);
    public void saveDefaults();
    public void displayManuscript(String imagefile) throws Exception;
    public void saveState();
    public void setCurrentPage(String manuscriptDirectory, String pageName);
    public void bringToFront();
    public void reloadAnnotations(String currentDirname, String currentFilename) throws Exception;
    public void newAnnotation (boolean onlyIfTextIsSelected);
}
