package sita;
import java.awt.event.ActionEvent;
import java.awt.event.KeyEvent;
import javax.swing.JDialog;
import java.awt.BorderLayout;
import javax.swing.JLabel;
import javax.swing.JPanel;
import java.awt.Color;
import java.awt.event.ActionListener;
import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JColorChooser;
import javax.swing.JComponent;
import javax.swing.JTextField;
import javax.swing.KeyStroke;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

// http://www.java2s.com/Code/Java/Swing-JFC/JColorChooserdialogwithacustompreviewpane.htm

public class AppearanceDialog extends JDialog implements ChangeListener, ActionListener
{
    ApplicationState appstate;
    JLabel banner;
    JColorChooser tcc;
    Annotated annotater;
    JPanel resizePanel;
    JButton btnChangeSize;
    JButton btnRestore;
    Color originalPointColor;
    int originalPointSize;

    public AppearanceDialog(ApplicationState appstate, Annotated annotater)
    {
        this.appstate = appstate;
        this.annotater = annotater;

        setLayout(new BorderLayout());
        setBounds(0, 0, 600, 400);
        Utils.centerScreen(this);
        setModal(false);
        this.setAlwaysOnTop(true);
        Utils.setEscapeKeyListener(this);


        //Set up the banner at the top of the window

        //Set up color chooser for setting text color
        tcc = new JColorChooser();
        tcc.getSelectionModel().addChangeListener(this);
        tcc.setBorder(BorderFactory.createTitledBorder("Choose Marker Color"));
        tcc.setPreviewPanel(new JLabel(""));

        add(tcc, BorderLayout.CENTER);

        resizePanel = new JPanel();

        btnChangeSize = new JButton("Change size");
        btnChangeSize.setActionCommand("changesize");
        btnChangeSize.addActionListener(this);

        btnRestore = new JButton("Restore original");
        btnRestore.setActionCommand("restore");
        btnRestore.addActionListener(this);

        resizePanel.add(btnRestore);

        add(resizePanel, BorderLayout.SOUTH);
    }


    public void initialize()
    {
        tcc.setColor(annotater.getColor());
        originalPointColor = appstate.getPointColor();
        originalPointSize = appstate.getPointSize();
    }

    public void stateChanged(ChangeEvent e)
    {
        Color newColor = tcc.getColor();
        annotater.setColor(newColor);
    }

    public void actionPerformed(ActionEvent e)
    {
        String actionCommand = e.getActionCommand();
        if (actionCommand.equals("restore"))
            annotater.setColor(originalPointColor);
    }

}
