package sita;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import javax.swing.BorderFactory;
import javax.swing.JScrollPane;


public class CommentScrollPage extends JScrollPane implements FocusListener
{
    ApplicationState appstate;
    CommentArea comment;
    MarkedPanel markedPanel;

    public CommentScrollPage(ApplicationState appstate, int numRows, int numCols, Dimension size)
    {
        this.appstate = appstate;
        comment = new CommentArea(appstate, numRows, numCols, false, size);
        this.setViewportView(comment);
        this.setSize(size);

    }

    public void insertCannedComment()
    {
        comment.insertCannedComment();
    }

    public void setMarkedPanel(MarkedPanel markedPanel)
    {
        comment.setMarkedPanel(markedPanel);
    }


    public void saveSelection()
    {
        appstate.setComment(comment.getText());
    }

    public String getText()
    {
        return comment.getText();
    }

    public void display()
    {
        comment.setText(appstate.getComment());
    }

    public void debug(String s)
    {
        comment.setText(s);
    }

    public void debugAppend(String s)
    {
        comment.setText(comment.getText() + s);
    }

    public void setFocus()
    {
        comment.grabFocus();
    }

    public void focusGained(FocusEvent e)
    {
        setBorder(BorderFactory.createLineBorder(Color.red));
    }

    public void focusLost(FocusEvent e)
    {
        setBorder(BorderFactory.createLineBorder(Color.black));
    }

}
