package sita;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;

public class ConfirmationDialog extends JDialog implements ActionListener
{
    JLabel message;
    JButton button1;
    JButton button2;
    boolean result;
    ApplicationState appstate;

    public ConfirmationDialog(ApplicationState appstate)
    {
        this.appstate = appstate;
        Utils.setEscapeKeyListener(this);
        
        setLayout(new BorderLayout());

        message = new JLabel();
        message.setPreferredSize(new Dimension(400, 200));
        Utils.centerScreen(this);
        setModal(true);
        add(message, BorderLayout.CENTER);

        JPanel buttonPanel = new JPanel();
        button1 = new JButton("");
        button1.setActionCommand("true");
        button1.setPreferredSize(new Dimension(50, 20));
        button1.addActionListener(this);
        buttonPanel.add(button1);

        button2 = new JButton("");
        button2.setActionCommand("false");
        button2.setPreferredSize(new Dimension(50, 20));
        button2.addActionListener(this);
        buttonPanel.add(button2);

        add(buttonPanel, BorderLayout.SOUTH);
    }

    public void setMessage(String text, String trueButton, String falseButton)
    {
        result = false;
        message.setText(text);
        button1.setText(trueButton);
        button2.setText(falseButton);
    }

    public boolean getResult()
    {
        return result;
    }

    public void actionPerformed(ActionEvent e)
    {
        result = e.getActionCommand().equals("true");
    }
}
