package sita;

import java.awt.*;

public class DrawingPanel extends RubberBandPanel
{
   protected RubberBand rbRect;
   protected ApplicationState appstate;
   private Color   color;
   private boolean fill;

   public DrawingPanel(ApplicationState appstate)
   {
      this.appstate = appstate;
      rbRect = new RubberBandRectangle(appstate, this);
      setRubberBand(rbRect);
   }

   public void rubberBandEnded(RubberBand rubberband)
   {
      drawShape(rubberband);
   }

   public void bracketsEnded(RubberBand rubberband)
   {

   }

   public void drawRectangles()
   {
       setRubberBand(rbRect);
   }

   public void    setFill(boolean b) { fill = b;    }
   public boolean getFill()          { return fill; }

   protected void drawShape(RubberBand rb)
   {
      Graphics   g  = getGraphics();

      if(g != null)
      {
         try
         {
            g.setColor(rb.getPointColor());

            drawRectangle(rb, g);
         }
         finally
         {
            g.dispose();
         }
      }
   }

   protected void drawRectangle(RubberBand rb, Graphics g)
   {
      Rectangle r = rb.getBounds();

      g.drawRect(r.x, r.y, r.width, r.height);
   }
}


