package sita;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.text.NumberFormat;
import javax.swing.AbstractAction;
import javax.swing.ActionMap;
import javax.swing.InputMap;
import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JDialog;
import javax.swing.JFormattedTextField;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JRootPane;
import javax.swing.KeyStroke;


public class GoToDialog extends JDialog implements ActionListener {
    private static final String TEXT_SUBMIT = "text-submit";
    private static final String TEXT_ESCAPE = "text-escape";

    JFormattedTextField numberField;
    JButton OK;
    String oldLine = "";
    boolean jumpToLine = false;

    public GoToDialog (JFrame parent) {
        super(parent);

        setLayout(null);
        this.setModalityType(ModalityType.DOCUMENT_MODAL);

        JLabel label = new JLabel("Enter text line number to go to.");
        label.setBounds(10, 10, 200, 30);
        label.setOpaque(true);
        add(label);

        numberField = new JFormattedTextField(NumberFormat.getInstance());
        numberField.setBounds(10, 45, 200, 30);
        add(numberField);
    
        numberField.addAncestorListener(new RequestFocusListener());
        InputMap input = numberField.getInputMap();
        KeyStroke enter = KeyStroke.getKeyStroke("ENTER");
        input.put(enter, TEXT_SUBMIT);

        KeyStroke escape = KeyStroke.getKeyStroke("ESCAPE");
        input.put(escape, TEXT_ESCAPE);

        ActionMap actions = numberField.getActionMap();
        actions.put(TEXT_SUBMIT, new AbstractAction() {

            @Override
            public void actionPerformed(ActionEvent e) {
                submit(e);
            }
        });


        OK = new JButton("OK");
        OK.setBounds(10, 75, 50, 30);
        OK.addActionListener(this);
        this.add(OK);


        KeyStroke esc = KeyStroke.getKeyStroke(KeyEvent.VK_ESCAPE, 0);
        this.getRootPane().registerKeyboardAction(this, esc, JComponent.WHEN_IN_FOCUSED_WINDOW);

        this.setBounds(0, 0, 225, 150);
        Utils.centerScreen(this);
    }

    public void display () {
        numberField.setText(oldLine);
        setVisible(true);
    }

    private void submit (ActionEvent e) {
        if (e.getSource() == OK || e.getActionCommand().equals("\n")) {
            oldLine = numberField.getText();
            jumpToLine = oldLine.length() > 0;
        } else {
            numberField.setText(oldLine);
            jumpToLine = false;
        }

        setVisible(false);

    }

    public void actionPerformed(ActionEvent e) {
        if (e.getSource().getClass() == JRootPane.class) {
            numberField.setText(oldLine);
            setVisible(false);
	} else {
            submit(e);
        }
    }



    public int getLine () {
        int n = 0;
        if (oldLine.length() > 0) {
            n = Integer.parseInt(oldLine);
        }

        return n;
    }

    public boolean getJumpToLine () {
        return jumpToLine;
    }

}
