/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package sita;

import java.awt.Color;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.Hashtable;
import org.sanskritlibrary.IOAssistance;
import org.sanskritlibrary.SAXParser;
import org.sanskritlibrary.SAXParserHandler;
import org.xml.sax.Attributes;
import org.xml.sax.Locator;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;

/**
 *
 * @author ralph
 */
public class MachineGeneratedParser implements SAXParserHandler {

    private Hashtable<String, DefaultInfo> defaults;
    private Hashtable<String, ArrayList<OffsetInfo>> virtualFileOffsets = new Hashtable<String, ArrayList<OffsetInfo>>();
    private ArrayList<OffsetInfo> virtualFile = null;
    private Locator locator;
    private SAXParser sp;
    private String filename;
    private String virtualFilename;
    private String manuscriptRootDirectory = "";
    private String annotationsBackupDirectory = "";
    private String catalogDirectory = "";
    //private String backupDirectory = "";
    private String textDirectory = "";
    private String currentElement = null;
    private String currentDirectoryType = null;

    public MachineGeneratedParser(String filename) throws Exception {
        try {
            this.filename = filename;
            sp = new SAXParser(this);
            sp.parse(filename);
        } catch (Exception ex) {
            Utils.displayError(ex);
            throw ex;
        }
    }

    public void parse () {

    }

    public Hashtable<String, DefaultInfo> getDefaults() {
        return defaults;
    }

    public Hashtable<String, ArrayList<OffsetInfo>>  getVirtualFileOffsets () {
        return virtualFileOffsets;
    }

    public void setVirtualFileOffsets (Hashtable<String, ArrayList<OffsetInfo>> virtualFileOffsets) {
        this.virtualFileOffsets = virtualFileOffsets;
    }


    public void setManuscriptRootDirectory (String manuscriptRootDirectory) {
        this.manuscriptRootDirectory = manuscriptRootDirectory;        
    }
    
    public String getManuscriptRootDirectory () {
        return manuscriptRootDirectory == null ? "?" : manuscriptRootDirectory;
    }

    public void setAnnotationsBackupDirectory (String annotationsBackupDirectory) {
            this.annotationsBackupDirectory = annotationsBackupDirectory;
    }

    public String getAnnotationsBackupDirectory () {
        return annotationsBackupDirectory == null ? "?" : annotationsBackupDirectory;
    }

    public void setCatalogDirectory(String catalogDirectory) {
        this.catalogDirectory = catalogDirectory;
    }

    public String getCatalogDirectory() {
        return catalogDirectory;
    }


    /*
    public void setBackupDirectory(String backupDirectory) throws Exception
    {
        this.annotationsBackupDirectory = backupDirectory;
    }

    public String getBackupDirectory()
    {
        return annotationsBackupDirectory;
    }
     */

    public void setTextDirectory(String textDirectory) throws Exception
    {
        this.textDirectory = textDirectory;
    }

    public String getTextDirectory()
    {
        return textDirectory;
    }

    public void warning(SAXParseException exception) throws SAXException {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public void error(SAXParseException exception) throws SAXException {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public void fatalError(SAXParseException exception) throws SAXException {
        throw exception;
    }

    public void setDocumentLocator(Locator locator) {
        this.locator = locator;
    }

    public void startDocument() throws SAXException {
    }

    public void endDocument() throws SAXException {
    }

    public void startPrefixMapping(String prefix, String uri) throws SAXException {
    }

    public void endPrefixMapping(String prefix) throws SAXException {
    }

    public void startElement(String uri, String localName, String qName, Attributes atts) throws SAXException {
        currentElement = qName;
        
        if (qName.equals("directory")) {
            currentDirectoryType = atts.getValue("type");
            if (currentDirectoryType == null)
                msg("directory element needs a type attribute");
        }

        if (qName.equals("defaults"))
            defaults = new Hashtable<String, DefaultInfo>();
        else if (qName.equals("default"))
        {
            String value = atts.getValue("name");
            if (value == null)
                throw new SAXException("default needs a name attribute");
            String name = value;

            value = atts.getValue("divider");
            double divider = 0.5;
            if (value != null)
                divider = Double.parseDouble(value);

            value = atts.getValue("pointColor");
            Color pointColor = Color.red;
            if (value != null)
                pointColor = new Color(Integer.parseInt(value));

            value = atts.getValue("width");
            int width = 500;
            if (value != null)
                width = Integer.parseInt(value);

            value = atts.getValue("orient");
            char orientation = '|';
            if (value != null)
                orientation = value.charAt(0);

            int fontsize = 12;
            value = atts.getValue("fontsize");
            if (value != null)
                fontsize = Integer.parseInt(value);

            String oldEncoding = null;
            value = atts.getValue("oldEncoding");
            if (value != null)
                oldEncoding = value;

            String newEncoding = null;
            value = atts.getValue("newEncoding");
            if (value != null)
                newEncoding = value;

            DefaultInfo di = new DefaultInfo(name, divider, pointColor, width, orientation, fontsize);
            if (oldEncoding != null)
                di.setOldEncoding(oldEncoding);
            if (newEncoding != null)
                di.setNewEncoding(newEncoding);

            defaults.put(name, di);
        } else if (qName.equals("virtualFile")) {
            virtualFile = new ArrayList<OffsetInfo>();
            if (atts.getValue("name") != null) {
                virtualFilename = atts.getValue("name");
            } else {
                msg("a virtualFile element is missing a name attribute");
            }
        } else if (qName.equals("segment")) {
            try {
                OffsetInfo oi = new OffsetInfo(Integer.parseInt(atts.getValue("tabStart")));
                virtualFile.add(oi);
                if (atts.getValue("text") != null) {
                    oi.sourceFile = atts.getValue("text");
                    oi.startLineInSourceFile = Integer.parseInt(atts.getValue("textStart"));
                    oi.endLineInSourceFile = Integer.parseInt(atts.getValue("textEnd"));
                }

            } catch (Exception ex) {
                msg("start attribute of segment element must be an integer");
            }
        }
    }

    public void endElement(String uri, String localName, String qName) throws SAXException {
        currentElement = null;
        if (qName.equals("virtualFile")) {
            virtualFileOffsets.put(virtualFilename, virtualFile);
            virtualFile = null;
        }
    }

    public void characters(char[] ch, int start, int length) throws SAXException {
        String content = new String(ch, start, length);
        
        if (currentElement!=null && currentElement.equals("directory"))
        {
            if (currentDirectoryType.equals("manuscripts"))
                manuscriptRootDirectory += content;
            else if (currentDirectoryType.equals("catalog"))
                catalogDirectory += content;
            else if (currentDirectoryType.equals("texts"))
                textDirectory += content;
            else if (currentDirectoryType.equals("backup"))
                annotationsBackupDirectory += content;
        }

    }

    public void msg(String text) throws SAXException
    {
        throw new SAXException(String.format("In machineGenerated.xml, %d.%d %s", locator.getLineNumber(), locator.getColumnNumber(), text));
    }

    public void toXML () throws Exception {
        FileWriter fw = IOAssistance.openUncachedWriter(filename);
        fw.write("<!-- This file is machine-generated. Any changes you make to it will be lost. -->\n");
        fw.write("<machineGenerated>\n");

        fw.write(String.format("\t<directory type='manuscripts'>%s</directory>\n", manuscriptRootDirectory));
        fw.write(String.format("\t<directory type='catalog'>%s</directory>\n", catalogDirectory));
        fw.write(String.format("\t<directory type='texts'>%s</directory>\n", textDirectory));
        fw.write(String.format("\t<directory type='backup'>%s</directory>\n", annotationsBackupDirectory));

        fw.write("\t<virtualFiles>\n");
        Enumeration<String> en = virtualFileOffsets.keys();
        while (en.hasMoreElements()) {
            String key = en.nextElement();
            fw.write(String.format("\t\t<virtualFile name='%s'>\n", key));
            ArrayList<OffsetInfo> segments = virtualFileOffsets.get(key);
            for (OffsetInfo segment : segments) {
                fw.write(String.format("\t\t\t<segment tabStart='%d'", segment.offsetInVirtualFile));
                if (segment.sourceFile != null) {
                    fw.write(String.format(" text='%s' textStart='%d' textEnd='%d'",
                            segment.sourceFile, segment.startLineInSourceFile, segment.endLineInSourceFile));
                }
                fw.write("/>\n");
            }
            fw.write(String.format("\t\t</virtualFile>\n"));
        }
        fw.write("\t</virtualFiles>\n");
        fw.write("\t<defaults>\n");

        Enumeration<String> e = defaults.keys();
        while (e.hasMoreElements())
        {
            String name = e.nextElement();
            DefaultInfo di = defaults.get(name);
            String newEncoding = di.newEncoding;
            if (newEncoding != null)
                newEncoding = String.format("newEncoding='%s'", newEncoding);
            else
                newEncoding = "";

            String oldEncoding = di.oldEncoding;
            if (oldEncoding != null)
                oldEncoding = String.format("oldEncoding='%s'", oldEncoding);
            else
                oldEncoding = "";

            fw.write(String.format("\t\t<default name='%s' divider='%s' pointColor='%d' width='%d' orient='%c' fontsize='%d' %s %s/>\n",
                    name, Double.toString(di.divider),
                    di.pointColor.getRGB(), di.resolvedWidth, di.orientation, di.fontsize,
                    oldEncoding, newEncoding));
        }
        fw.write("\t</defaults>\n");
        fw.write("</machineGenerated>\n");
        fw.close();
    }
}
