package sita;

import java.util.Hashtable;
import java.util.ArrayList;
import java.io.File;
import org.xml.sax.Attributes;
import org.xml.sax.Locator;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;
//import org.xml.sax.EntityResolver;
//import org.xml.sax.DTDHandler;
//import org.xml.sax.ContentHandler;
//import org.xml.sax.ErrorHandler;

import javax.xml.parsers.SAXParserFactory;
import javax.xml.parsers.SAXParser;

public class Pages extends DefaultHandler //implements ErrorHandler, ContentHandler, DTDHandler, EntityResolver
{
    private String currentDirectory;
    private Locator locator;
    
    public Hashtable<String, ArrayList<String>> data;

    public Pages(String fileName) throws Exception
    {
        // Use the default (non-validating) parser
        SAXParserFactory factory = SAXParserFactory.newInstance();

        // Parse the input
        SAXParser saxParser = factory.newSAXParser();
        saxParser.parse( new File(fileName), this);
    }

    public ArrayList<String> getPages(String directoryName)
    {
        return data.get(directoryName);
    }

    // For ContentHandler
    @Override
    public void setDocumentLocator(Locator locator)
    {
        this.locator = locator;
    }

    @Override

    public void startDocument() throws SAXException
    {
        data = new Hashtable<String, ArrayList<String>>();
    }

    @Override
    public void endDocument() throws SAXException
    {
    }


    @Override
    public void startElement(String uri, String localName, String qName, Attributes atts) throws SAXException
    {
        if (qName.equals("directory"))
        {
            currentDirectory = atts.getValue("name");
            if (currentDirectory == null)
                throw new SAXException("directory element does not have a name attribute");

            data.put(currentDirectory, new ArrayList<String>());
        }
        else if (qName.equals("page"))
        {
            ArrayList<String> a = data.get(currentDirectory);
            String filename = atts.getValue("name");
            if (filename == null)
                throw new SAXException("page element does not have a name attribute");
            else
                a.add(filename);
        }
    }

    @Override
    public void endElement(String uri, String localName, String qName) throws SAXException
    {
    }

    @Override
    public void characters(char[] ch, int start, int length) throws SAXException
    {
    }

    private void msg(String text) throws SAXException
    {
        throw new SAXException(String.format("%d.%d %s", locator.getLineNumber(), locator.getColumnNumber(), text));
    }

}
