package sita;

import java.awt.Color;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import javax.swing.JTextField;

public class RestorableTextField extends JTextField implements FocusListener
{
    protected MarkedPanel markedPanel;

    public RestorableTextField()
    {
        super();
        this.addFocusListener(this);
    }

    public void setMarkedPanel(MarkedPanel markedPanel)
    {
        this.markedPanel = markedPanel;
    }

    public void focusGained(FocusEvent e)       // FocusListener
    {
        if (markedPanel != null)
            markedPanel.setColor(Color.red);
    }

    public void focusLost(FocusEvent e)         // FocusListener
    {
        if (markedPanel != null)
            markedPanel.setColor(Color.white);
    }
}
