package sita;

import java.awt.event.*;
import javax.swing.JPanel;

abstract public class RubberBandPanel extends JPanel
{
    private RubberBand rubberband;

    abstract public void rubberBandEnded(RubberBand rb);
    abstract public void bracketsEnded(RubberBand rb);

    public void setRubberBand(RubberBand rb)
    {
       rubberband = rb;
    }

    public RubberBand getRubberBand()
    {
       return rubberband;
    }


    @Override
    public void processMouseEvent(MouseEvent event)
    {
       super.processMouseEvent(event);  // fire to listeners

       if(rubberband != null && event.getID() == MouseEvent.MOUSE_RELEASED)
       {
          if (rubberband.getBoxExists())
            rubberBandEnded(rubberband);
          else if (rubberband.getLeftBracketExists())
            bracketsEnded(rubberband);
       }

    }
}

