package sita;

import java.util.ArrayList;
import java.util.Hashtable;
import org.sanskritlibrary.Text;
import org.sanskritlibrary.webservice.TransformMap;

public class SegmentInfo {

    private Text.Type type;
    public String content;
    public String source;
    public String matcher;
    public String start;
    public String end;
    public Hashtable<String, Boolean> mapspecs;

    public SegmentInfo (String stype, String content, String source, 
            String matcher, String start, String end, Hashtable<String, Boolean> mapspecs) {
        stype = stype.toLowerCase();
        if (stype.equals("bookmark")) {
            this.type = Text.Type.Bookmark;
        } else if (stype.equals("comment")) {
            this.type = Text.Type.Comment;
        } else if (stype.equals("text")) {
            this.type = Text.Type.TextRef;
        } else {
            this.type = Text.Type.Unknown;
        }

        this.content = content;
        this.source = source;
        this.matcher = matcher;
        this.start = start;
        this.end = end;
        this.mapspecs = mapspecs;
    }


    boolean isBookmark () {
        return type == Text.Type.Bookmark;
    }

    boolean isComment () {
        return type == Text.Type.Comment;
    }

    boolean isText () {
        return type == Text.Type.TextRef;
    }

    Text.Type getType () {
        return type;
    }
}
