package sita;

/*
import java.io.File;
import com.sun.media.jai.codec.SeekableStream;
import com.sun.media.jai.codec.FileSeekableStream;
import com.sun.media.jai.codec.TIFFDecodeParam;
import com.sun.media.jai.codec.ImageDecoder;
import com.sun.media.jai.codec.ImageCodec;
import com.sun.media.jai.codec.JPEGEncodeParam;
import com.sun.media.jai.codec.ImageEncoder;
import java.awt.image.RenderedImage;
import java.io.FileOutputStream;
*/
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.image.BufferedImage;
import java.awt.Cursor;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Point;
import java.awt.Rectangle;
import javax.swing.JDialog;
import javax.swing.JLabel;
import java.util.Calendar;
import java.text.SimpleDateFormat;
import javax.swing.SwingConstants;
import java.awt.Image;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import javax.imageio.ImageIO;
import javax.swing.JComponent;
import javax.swing.KeyStroke;
import org.sanskritlibrary.IOAssistance;
import java.util.Date;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.ScrollPaneConstants;


public class Utils
{
    private static final String DATE_FORMAT_NOW = "yyyy-MM-dd HH:mm:ss";

// from: http://www.rgagnon.com/javadetails/java-0106.html
    public static String now()
    {
        Calendar cal = Calendar.getInstance();
        SimpleDateFormat sdf = new SimpleDateFormat(DATE_FORMAT_NOW);
        return sdf.format(cal.getTime());
    }

    static public void centerScreen(JDialog dlg)
    {
        Dimension dim = dlg.getToolkit().getScreenSize();
        Rectangle abounds = dlg.getBounds();
        dlg.setLocation((dim.width - abounds.width) / 2, (dim.height - abounds.height) / 2);
    }


    static public void upperRightScreen(JDialog dlg)
    {
        Dimension dim = dlg.getToolkit().getScreenSize();
        Rectangle abounds = dlg.getBounds();
        dlg.setLocation((dim.width - abounds.width), 0);
    }

    static void displayWaitCursor(Component cmp)
    {
        Cursor hourglassCursor = new Cursor(Cursor.WAIT_CURSOR);
        cmp.setCursor(hourglassCursor);
    }

    static void displayDefaultCursor(Component cmp)
    {
        Cursor normalCursor = new Cursor(Cursor.DEFAULT_CURSOR);
        cmp.setCursor(normalCursor);
    }


    
    static public boolean isTiffFile(String filename)
    {
        return filename.endsWith(".tiff");
    }

/*
    static public boolean jpegExists(String filename)
    {
        filename = createJpegFileName(filename);
        return new File(filename).exists();
    }
*/

/*
    static public String createJpegFileName(String filename)
    {
        File f = new File(filename);
        String fn = f.getName();
        Regex re = new Regex(fn, "\\.([^.]+)$");
        if (re.find())
        {
            String extension = re.getGroup(1);
            if (!extension.equals("jpg"))
                fn = fn.substring(0, fn.length()-extension.length()) + "jpg";
            return String.format("%s%s", ManuscriptConfiguration.jpegDirectory, fn);
        }
        else
            return null;
    }
*/

/*
    static public void convertTIFFtoJPEG(String filename) throws Exception
    {
        SeekableStream s = new FileSeekableStream(new File(filename));
        TIFFDecodeParam param = null;
        ImageDecoder dec = ImageCodec.createImageDecoder("tiff", s, param);
        RenderedImage op1 = dec.decodeAsRenderedImage();
        int x = op1.getWidth();
        int y = op1.getHeight();
        FileOutputStream fos = new FileOutputStream(createJpegFileName(filename));
        JPEGEncodeParam jparam = new JPEGEncodeParam();
        jparam.setQuality(0.5f); // e.g. 0.25f
        ImageEncoder encoder = ImageCodec.createImageEncoder("JPEG", fos, jparam);
        try
        {
            encoder.encode(op1);
        }
        catch (Exception ex)
        {

        }
        fos.close();
        s.close();
    }
*/

    static int computeHeight(int width, BufferedImage image)
    {
        return (int)(width * ((double)image.getHeight()/(double)image.getWidth()));
    }
/*
    static public void displayError(JFrame f, Exception ex)
    {
        JDialog dlg = new JDialog(f, true);
        _displayError(dlg, ex);
    }

    static public void displayError(JDialog dialog, Exception ex)
    {
        JDialog dlg = new JDialog(dialog, true);
        _displayError(dlg, ex);
    }
*/
    static public void displayError(Exception ex)
    {
        ErrorDialog dlg = new ErrorDialog();
        _displayError(dlg, ex);
    }

    static public void displayError(String error)
    {
        displayError(new Exception(error));
    }

    static private void _displayError(ErrorDialog dlg, Exception ex)
    {
        Utils.displayDefaultCursor(dlg);

        String s = Logger.writeLog(ex);
        dlg.setTitle("An error occurred");
        dlg.getInsets().set(20, 20, 20, 20);
        dlg.setLayout(new BorderLayout());
        JLabel message = new JLabel(String.format("<html>%s</html>", s));
        message.setVerticalAlignment(SwingConstants.TOP);
        dlg.add(message, BorderLayout.CENTER);
        message = new JLabel("<html>Please email log.txt to rbunker@mum.edu with a description of what you were doing just before this message appeared.</html>");
        message.setForeground(Color.red);
        message.setVerticalAlignment(SwingConstants.TOP);
        dlg.add(message, BorderLayout.SOUTH);
        dlg.setBounds(0, 0, 600, 200);
        centerScreen(dlg);
        dlg.setVisible(true);
        dlg.setModal(true);

    }

    public static void displayWarning(String msg)
    {
        JDialog dlg = new JDialog();
        setEscapeKeyListener(dlg);
        msg = msg.replaceAll("/", "&#47;");
        dlg.getInsets().set(20, 20, 20, 20);
        dlg.setLayout(new BorderLayout());
        JLabel message = new JLabel(String.format("<html>%s</html>", msg));
        message.setVerticalAlignment(SwingConstants.TOP);
        message.setHorizontalAlignment(SwingConstants.LEFT);
        JPanel messagePanel = new JPanel();
        messagePanel.add(message);
        JScrollPane messageScrollPane = new JScrollPane(messagePanel);
        messageScrollPane.setPreferredSize(new Dimension(550, 250));
//        messageScrollPane.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_ALWAYS);
//        messageScrollPane.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);
        dlg.add(messageScrollPane, BorderLayout.CENTER);
        dlg.setBounds(0, 0, 600, 300);
        centerScreen(dlg);
        dlg.setModal(true);
        dlg.setAlwaysOnTop(true);
        dlg.setVisible(true);
    }

    public static String removeBraces(String line, char startBrace)
    {
        char endBrace;
        if (startBrace == '[')
            endBrace = ']';
        else if (startBrace == '{')
            endBrace = '}';
        else
            return null;

        StringBuilder sb = new StringBuilder();
        int len = line.length();
        for (int i=0; i<len; i++)
        {
            char ch = line.charAt(i);
            if (ch == startBrace)
            {
                if (i+2<len && line.charAt(i+2) == endBrace)
                {
                    sb.append(line.charAt(i+1));
                    i += 2;
                }
                else
                    sb.append(ch);
            }
            else
                sb.append(ch);
        }

        return sb.toString();
    }

    static public String displayRect(Rectangle r)
    {
        return String.format("x=%d, y=%d, width=%d, height=%d",
                (int)r.getX(), (int)r.getY(), (int)r.getWidth(), (int)r.getHeight());
    }

   static public void adjustPoint(Point pt, Point pt2, int before, int after)
   {
       if (before > 0 && after > 0 && before != after)
       {
            double adjustment = (double)after/(double)before;
            pt2.x = (int)Math.round(pt.x * adjustment);
            pt2.y = (int)Math.round(pt.y * adjustment);
       }
   }

   static public void adjustPoint(PrecisePoint pt, int before, int after)
   {
       if (before > 0 && after > 0 && before != after)
       {
            double adjustment = (double)after/(double)before;
            pt.x = pt.x * adjustment;
            pt.y = pt.y * adjustment;
       }
   }

   static public int adjustValue(int value, int before, int after)
   {
       if (before > 0 && after > 0 && before != after)
       {
            double adjustment = (double)after/(double)before;
            return (int)Math.round(value * adjustment);
       }
       else
           return value;
   }

    static public void adjustRectangle(Rectangle r, int before, int after)
    {
        if (before > 0 && after > 0 && before != after)
        {
            if (r.x != -1)
                r.x = adjustValue(r.x, before, after);

            if (r.y != -1)
                r.y = adjustValue(r.y, before, after);

            if (r.width != -1)
                r.width = adjustValue(r.width, before, after);

            if (r.height != -1)
                r.height = adjustValue(r.height, before, after);
        }
    }

    static public void saveImage(Image im, int width, int height)
    {
        BufferedImage bi = new BufferedImage(width, height, BufferedImage.TYPE_INT_RGB);
        Graphics g = bi.getGraphics();
        g.drawImage(im, 0, 0, width, height, null);

        try
        {
            FileOutputStream out = new FileOutputStream("image.jpg");
            ImageIO.write(bi, "jpg", out);
            out.close();
        }
        catch (IOException ex)
        {
            displayError(ex);
        }
    }

    public static void setEscapeKeyListener(final JDialog dlg)
    {
        KeyStroke stroke = KeyStroke.getKeyStroke(KeyEvent.VK_ESCAPE, 0);
        ActionListener al =  new ActionListener()
                {
                    public void actionPerformed(ActionEvent actionEvent) {
                    dlg.setVisible(false);
                }
        };

        dlg.getRootPane().registerKeyboardAction(al, stroke, JComponent.WHEN_IN_FOCUSED_WINDOW);

    }

    public static String testWritableFile(String filename)
    {
        try
        {
            File f = new File(filename);
            if (!f.exists())
            {
                BufferedWriter bw = IOAssistance.openWriter(filename);
                bw.close();
            }
            else
                IOAssistance.append(filename, "");
        }
        catch (Exception ex)
        {
            return ex.getMessage();
        }

        return null;
    }

    static public int getLineNumber(String buffer, int last)
    {
        int lineno = 0;
        for (int i = 0; i < last - 1; i++)
        {
            if (buffer.charAt(i) == 0x0d || buffer.charAt(i) == 0x0a)
            {
                lineno++;
                if (buffer.charAt(i) == 0x0d && buffer.charAt(i+1) == 0x0a)           // in case 0x0d 0x0a used for eol
                    i++;
            }
        }

        return lineno;
    }


    static public int getLineNumber(String buffer, int currentPosition, int[] lineStartOffset)
    {
        int lineno = 0;
        int len = buffer.length();
        for (int i = 0; i < currentPosition && i<len; i++)
        {
            if (buffer.charAt(i) == 0x0d || buffer.charAt(i) == 0x0a)
            {
                lineno++;
                if (buffer.charAt(i) == 0x0d && i+1 < currentPosition && buffer.charAt(i+1) == 0x0a)           // in case 0x0d 0x0a used for eol
                    i++;
                lineStartOffset[0] = i + 1;
            }
        }

        return lineno;
    }


    static public boolean copyDirectory(File sourceLocation, File targetLocation)
    {
        try
        {
            if (sourceLocation.isDirectory())
            {
                if (!targetLocation.exists())
                {
                    targetLocation.mkdir();
                }

                String[] children = sourceLocation.list();
                for (int i = 0; i < children.length; i++)
                {
                    copyDirectory(new File(sourceLocation, children[i]), new File(targetLocation, children[i]));
                }
            }
            else
            {

                InputStream in = new FileInputStream(sourceLocation);
                OutputStream out = new FileOutputStream(targetLocation);

                // Copy the bits from instream to outstream
                byte[] buf = new byte[1024];
                int len;
                while ((len = in.read(buf)) > 0)
                {
                    out.write(buf, 0, len);
                }
                in.close();
                out.close();
            }
        }
        catch (Exception ex)
        {
            Logger.writeLog(ex);
            return false;
        }

        return true;
    }


    static public boolean deleteDirectory(File dir)
    {
        if (dir.isDirectory())
        {
            String[] children = dir.list();
            for (int i=0; i<children.length; i++)
            {
                boolean success = deleteDirectory(new File(dir, children[i]));
                if (!success)
                    return false;
            }
        }

        // Delete the file or the empty directory
        return dir.delete();
    }


    static public String getDateTime()
    {
        DateFormat dateFormat = new SimpleDateFormat("yyyy_MM_dd_HH_mm_ss");
        Date date = new Date();
        return dateFormat.format(date);
    }

    static public void displayReviewOnlyWarning () {
        displayWarning("You are in review only mode. Change this in the Annotations menu");
    }
}
