package org.sanskritlibrary;
import java.util.Comparator;
import java.util.ArrayList;

public class CatalogRecord implements Comparator
{
    String error = null;
    public String manuscriptType;
    public int seqno;
    public int numLeaves;
    public int numManuscriptFiles;
    public String catalogName;
    public String directoryName;
    public String foliation;
    public String title;
    public String subtitle;

    public ArrayList<TabInfo> tabs = new ArrayList<TabInfo>();
    public ArrayList<String> pages;
    public ArrayList<String> textTypes = new ArrayList<String>();
    String manuscriptRootDirectory;
//    XML filesdoc;

    public CatalogRecord()
    {
    }
/*
    public CatalogRecord(String catalogName, String foliation, String title, String subtitle, String textType, File f)
    {
        Regex re = new Regex(catalogName, "Item (\\d+)");
        String s = null;
        if (re.find())
        {
            s = re.getGroup(1);
            directoryName = f.getAbsolutePath().substring(3);  // strip off volume name
            if (!f.isDirectory())
                System.out.println("error");
            numManuscriptFiles = 0; 
            File[] dirfiles = f.listFiles();
            for (File file : dirfiles)
            {
                String fileName = file.getName();
                if (fileName.toLowerCase().contains(".tif") && fileName.charAt(0) != '.')
                    numManuscriptFiles++;
            }

            seqno = Integer.parseInt(s);
        }
        else
            System.out.format("%s has wrong format", catalogName);

        re = new Regex(foliation, "\\((\\d+)");
        if (re.find())
            numLeaves = Integer.parseInt(re.getGroup(1));
        this.catalogName = catalogName;
        this.foliation = foliation;
        this.title = title;
        this.subtitle = subtitle;
        this.textType.add(textType);
    }
*/
/*
    public CatalogRecord(XML doc, Hashtable<String, ArrayList<PageInfo>> manuscripts)
    {
        try
        {
            seqno = Integer.parseInt(doc.getAttribute("id"));
            directoryName = doc.getRelativeNode("directoryName").getTextContent();
            textType = doc.getRelativeNode("textType").getTextContent();
            catalogName = doc.getRelativeNode("catalogName").getTextContent();
            numLeaves = Integer.parseInt(doc.getRelativeNode("numLeaves").getTextContent());
            numManuscriptFiles = Integer.parseInt(doc.getRelativeNode("numFiles").getTextContent());
            title = doc.getRelativeNode("title").getTextContent();
            subtitle = doc.getRelativeNode("subtitle").getTextContent();
            files = manuscripts.get(directoryName);
        }
        catch (Exception e)
        {
            error = e.getMessage();
        }
    }
*/

    public void setManuscriptRootDirectory(String manuscriptRootDirectory)
    {
        this.manuscriptRootDirectory = manuscriptRootDirectory;
    }



    public ArrayList<String> getPages()
    {
        return pages;
    }

    public void setTextTypes () {
        if (tabs == null) {
            System.out.println("Call setTabs before calling setTextTypes");
            return;
        }
        for (TabInfo ti : tabs) {
            for (Text text : ti.texts) {
                if (text.type == Text.Type.TextRef) {
                    if (!textTypes.contains(text.ref)) {
                        textTypes.add(text.ref);
                    }
                }
            }
        }
    }

    public ArrayList<String> getTextTypes () {
        return textTypes;
    }

    public void setTabs (ArrayList<TabInfo> tabs) {
        this.tabs = tabs;
    }

    public void setPages(ArrayList<String> pages)
    {
        this.pages = pages;
    }

    public String getPage(int n)
    {
        try
        {
            return String.format("%s/%s/%s", manuscriptRootDirectory, directoryName, pages.get(n));
        }
        catch (Exception ex)
        {
            error = ex.getMessage();
            return null;
        }
    }

    public int compare(Object o1, Object o2)
    {
        CatalogRecord cr1 = (CatalogRecord)o1;
        CatalogRecord cr2 = (CatalogRecord)o2;

        //return cr1.name.compareToIgnoreCase(cr2.name);
        return cr1.seqno - cr2.seqno;
    }

    /*
    public String toXML()
    {
        String template = "<manuscript id='%d'>\n" +
        "\t<directoryName>%s</directoryName>\n" +
        "\t<textType>%s</textType>\n" +
        "\t<catalogName>%s</catalogName>\n" +
        "\t<numLeaves>%d</numLeaves>\n" +
        "\t<numFiles>%d</numFiles>\n" +
        "\t<title>%s</title>\n" +
        "\t<subtitle>%s</subtitle>\n" +
        "</manuscript>\n";

        return String.format(template,
                seqno,
                directoryName,
                tabs.toString(),
                catalogName,
                numLeaves,
                numManuscriptFiles,
                title,
                subtitle);
    }
     */

    @Override
    public String toString()
    {
        StringBuilder sb = new StringBuilder();
        if (directoryName != null)
            sb.append(directoryName);
        else
            sb.append(String.format("!%s", catalogName));
        sb.append(TextFormatter.toCol(sb, 35));
        sb.append("#leaves: ");
        sb.append(Integer.toString(numLeaves));
        sb.append(TextFormatter.toCol(sb, 50));
        sb.append("files: ");
        sb.append(Integer.toString(numManuscriptFiles));
        sb.append(TextFormatter.toCol(sb, 65));
        sb.append(String.format("%s (%s)", title, subtitle));
        return sb.toString();
    }
}
