package org.sanskritlibrary;

import java.io.File;
import java.util.ArrayList;
import java.util.Hashtable;
import org.xml.sax.Attributes;
import org.xml.sax.Locator;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;
import org.xml.sax.helpers.DefaultHandler;
import javax.xml.parsers.SAXParserFactory;
import javax.xml.parsers.SAXParser;

public class DictionaryLinks  extends DefaultHandler
{
    Locator locator;
    Hashtable<String, DictionaryLink> h = new Hashtable<String, DictionaryLink>();
    ArrayList<DictionaryLink> a = new ArrayList<DictionaryLink>();

    public DictionaryLinks(String filename) throws Exception
    {
        SAXParserFactory factory = SAXParserFactory.newInstance();
        try
        {
            // Parse the input
            SAXParser saxParser = factory.newSAXParser();
            saxParser.parse( new File(filename), this);
        }
        catch (Exception t)
        {
            throw new Exception(String.format("Line %d, Column %d: %s", locator.getLineNumber(), locator.getColumnNumber(), t.getMessage()));
        }
    }

    public ArrayList<DictionaryLink> getLinks()
    {
        return a;
    }

    public DictionaryLink getLink(String key)
    {
        return h.get(key);
    }

    @Override
    public void startElement(String uri, String localName, String qName, Attributes atts) throws SAXException
    {
        if (qName.equals("link"))
        {
            String key = atts.getValue("key");
            String pattern = atts.getValue("pattern");
            String title = atts.getValue("title");
            DictionaryLink di = new DictionaryLink(key, pattern, title);
            h.put(key, di);
            a.add(di);
        }
    }

    @Override
    public void endElement(String uri, String localName, String qName) throws SAXException
    {
    }

    @Override
    public void characters(char[] ch, int start, int length) throws SAXException
    {
    }

    // For ErrorHandler
    @Override
    public void warning(SAXParseException exception) throws SAXException
    {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    @Override
    public void error(SAXParseException exception) throws SAXException
    {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    @Override
    public void fatalError(SAXParseException exception) throws SAXException
    {
        throw exception;
    }

    // For ContentHandler
    @Override
    public void setDocumentLocator(Locator locator)
    {
        this.locator = locator;
    }

    @Override

    public void startDocument() throws SAXException
    {
    }

    @Override
    public void endDocument() throws SAXException
    {
    }

    @Override
    public void startPrefixMapping(String prefix, String uri) throws SAXException
    {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    @Override
    public void endPrefixMapping(String prefix) throws SAXException
    {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public class DictionaryLink
    {
        public String key;
        public String pattern;
        public String title;

        public DictionaryLink(String key, String pattern, String title)
        {
            this.key = key;
            this.pattern = pattern;
            this.title = title;
        }

        public String getKey()
        {
            return key;
        }

        public String getLink()
        {
            return pattern;
        }

        public String getTitle()
        {
            return title;
        }
    }
}
