package org.sanskritlibrary;

import java.util.ArrayList;
import org.w3c.dom.NodeList;
import org.xml.sax.Attributes;

public class Merge
{
    public String name;
    public ArrayList<Action> actions = new ArrayList<Action>();

    public Merge(XML doc) throws Exception
    {
        this.name = doc.getAttribute("name");

        NodeList list = doc.getRelativeNodeList("action");
        for (int i=0; i<list.getLength(); i++)
        {
            doc.pushNode(list.item(i));
            Action action = new Action(doc);
            actions.add(action);
            doc.popNode();
        }
    }

    public Merge(Attributes atts)
    {
        this.name = atts.getValue("name");
    }

    public void setAction(Action action)
    {
        actions.add(action);
    }

    public String getMergedValue(String in)
    {
        for (Action action : actions)
        {
            if (in.contains(action.in))
                return in.replaceAll(action.in, action.out);
        }

        return in;
    }
}
