package org.sanskritlibrary;
import java.util.Hashtable;
import java.util.ArrayList;

public class ParseState
{
	private ArrayList<Hashtable<String, String>> state;

	public ParseState()
	{
		state = new ArrayList<Hashtable<String, String>>();
	}

	public void pushState(String groupType)
	{
		state.add(new Hashtable<String, String>());
        try
        {
            if (groupType != null)
                addControlWord("_groupType", groupType);
        }
        catch (Exception ex){}      // can't happen
	}

	public void popState()
	{
		int last = state.size() - 1;
		if (last >= 0)
			state.remove(last);
	}


    public Hashtable<String, String> peekState()
    {
        return state.get(state.size() - 1);
    }

	public void addControlWord(String controlWord, String value) throws Exception
	{
		int last = state.size() - 1;
		if (last >= 0)
			state.get(last).put(controlWord, value==null ? "" : value);
		else
			throw new Exception("Parse stack is empty.");
	}

	public String get(String controlWord)
	{
		for (int i = state.size()-1; i>=0; i--)
		{
			String value = state.get(i).get(controlWord);
			if (value !=  null)
				return value;
		}

		return null;
	}


    // first see if controlWord is in pst, if not then start looking at index startHandle
	public String get(Hashtable<String, String>pst, int startHandle, String controlWord)
	{
        String value = pst.get(controlWord);
        if (value == null && startHandle >= 0)
        {
            for (int i = state.size()-1; i>=0; i--)
            {
                value = state.get(i).get(controlWord);
                if (value !=  null)
                    break;
            }
        }

		return value;
	}

    public int getCurrentHandle()
	{
		return state.size() - 1;
	}

	public String get(String key, int handle)
	{
		if (handle >=0 && handle < state.size())
			return state.get(handle).get(key);
		else
			return null;
	}

	public void update(String key, String value, int handle) throws Exception
	{
		if (handle >=0 && handle < state.size())
			state.get(handle).put(key, value);
		else
			throw new Exception(String.format("Illegal handle: %d", handle));
	}
}
