package org.sanskritlibrary;

import java.io.BufferedWriter;

public class PassThroughParser extends Parser
{
	BufferedWriter out;

    public boolean canHandle(RTF2 rtf, int n)
    {
        return true;
    }



	public int parse(RTF2 rtf, int start, ParseState ps) throws Exception
	{
        out = rtf.getOutput();
        String s = rtf.getRTF();
        int n = startup(rtf, start, "PassThroughParser");       // output initial { plus eols
        int end = PassThroughParser.skipGroup(s, n);
        if (out != null)
			out.write(s.substring(n, end));
        return end;
	}


    // n points to character after { that starts the group to skip
    static public int skipGroup(String s, int n) throws Exception
	{
		while (!eq(s, n, '}'))
		{
            if (eq(s, n, '{'))
                n = PassThroughParser.skipGroup(s, n+1);
            else
                n++;
		}

		return n + 1;  // points to character immediately after ending brace.
	}

    static private boolean eq(String s, int n, char ch)
    {
        boolean rc = false;
        if (s.charAt(n) == ch)
            rc = s.charAt(n-1) != '\\' || s.charAt(n-2) == '\\';

        return rc;
    }

	// this is called whenever a \fN control word is encounter (outside of a fonttbl group)
	public void handleToken(Token t, ParseState ps, StringBuffer accumulateBuffer) throws Exception
	{
	}

    // this is called whenever a \fN control word is encounter (outside of a fonttbl group)
	public void handleToken(Token t, ParseState ps) throws Exception
	{
	}
}
