package org.sanskritlibrary;

import java.util.regex.Pattern;

public class PerlRegex extends Regex {

    public PerlRegex(String text, String pattern) throws Exception
	{
        int flgs = 0;
        pattern = pattern.trim();
        if (pattern == null || pattern.length()<2) {
            throw new Exception("Pattern must be at least two character long");
        }
        char delim = pattern.charAt(0);
        int len = pattern.length();
        int last = len - 1;
        while (last >= 1) {
            if (pattern.charAt(last) == delim) {
                break;
            } else {
                last = last - 1;
            }

        }
        String flags = "";

        if (last == 0) {
            throw new Exception(String.format("Missing end %c", delim));
        }

        if (last != len - 1) {
            flags = pattern.substring(last+1);
        }

        if (flags != null){
            len = flags.length();
            for (int i=0; i<len; i++) {
                char ch = flags.charAt(i);
                switch (ch) {
                    case 'i': flgs |= Pattern.CASE_INSENSITIVE; break;
                    case 's': flgs |= Pattern.DOTALL; break;        // . matches eol
                    case 'm': flgs |= Pattern.MULTILINE; break;     // $ matches eol
                    default: throw new Exception(String.format("Illegal modifier: %c", ch));
                }
            }
        }
		p = Pattern.compile(pattern.substring(1, last), flgs);
		m = p.matcher(text);
	}


}
