package org.sanskritlibrary;
import java.nio.ByteBuffer;
import java.nio.CharBuffer;
import java.nio.charset.CharsetEncoder;
import java.nio.charset.CoderResult;
import java.nio.charset.Charset;

public class RawEncoder extends CharsetEncoder
{
	public RawEncoder(Charset cs, float averageBytesPerChar, float maxBytesPerChar)
	{
		super(cs, averageBytesPerChar, maxBytesPerChar);
	}

	public RawEncoder()
	{
		super(Charset.forName("UTF-8"), 1F, 1F);
	}

	@Override
	protected CoderResult encodeLoop(CharBuffer arg0, ByteBuffer arg1)
	{
		while (arg0.hasRemaining())
		{
			if (!arg1.hasRemaining())
				return CoderResult.OVERFLOW;

			int n = arg0.get();
			arg1.put((byte)n);
		}
		return CoderResult.UNDERFLOW;
	}
}
