package org.sanskritlibrary;
import java.util.regex.Pattern;
import java.util.regex.Matcher;

public class Regex
{
	protected Pattern p;
	protected Matcher m;

    public Regex () {       // so it can be extended
        
    }

	public Regex(String text, String pattern)
	{
		p = Pattern.compile(pattern);
		m = p.matcher(text);
	}

    public void reset(String text)
	{
		m.reset(text);
	}

	public boolean find()
	{
		return m.find();
	}

	public boolean matchEntireString()
	{
		return m.matches();
	}

	public String getGroup(int n)
	{
		return m.group(n);
	}

	public int getOffset(int n)
	{
		return m.start(n);
	}

	public int getGroupCount()      // return number of capturing groups
	{
		return m.groupCount();
	}

	public String replace(String replacement)
	{
		return m.replaceAll(replacement);
	}

	static public String replace(String s, String pattern, String replacement)
	{
		Pattern p = Pattern.compile(pattern);
		Matcher m = p.matcher(s);
		return m.replaceAll(replacement);
	}

	static public boolean matches(String s, String pattern)
	{
		return Pattern.matches(pattern, s);
	}
}
