package org.sanskritlibrary;

import java.util.Hashtable;

public class ResponseItem
{
	public int n;
	// 1=shift to suffixes,
	// 2=shift to prefixes,
	// 3=create result,
	// 4=create result and move current to result,

	public FSMEntry arg;
	public Hashtable<FSMEntry, Boolean> args;
	public String btype;

	public ResponseItem(int n, Object fe, Hashtable<FSMEntry, Boolean> args) throws Exception
	{
		this.n = n;
		if (fe == null)
			this.arg = null;
		else if (fe instanceof FSMEntry)
			this.arg = (FSMEntry)fe;
		else if (fe instanceof String)
			btype = (String)fe;
		else
			throw new Exception("Illegal type for fse argument");

		this.args = args;
	}

	public String formatCode()
	{
		switch (n)
		{
			case 1: return "Add to prefixes (1)";
			case 2: return "Add to body or test to continue (2)";
			case 3: return "Add to suffixes (3)";
			case 4: return "Create syllable twice (4)";
			case 5: return "Create syllable (5)";
			case 6: return "Conditionally create syllable (6)";
			case 7: return "Noop (7)";
			case 8: return "+ (8)";
			case 9: return "clear " + btype.charAt(0) + "(9)";
			case 10: return "Add to vowel letter buffer (10)";
			case 11: return "Make eligible (11)";
			case 12: return "Make ineligible (12)";
		}

		return "?";
	}
}
