// Define interface that SAXParser can use. This makes it easier to generate all the required methods.
package org.sanskritlibrary;

import org.xml.sax.Attributes;
import org.xml.sax.Locator;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;

public interface SAXParserHandler {
    public void warning(SAXParseException exception) throws SAXException;

    public void error(SAXParseException exception) throws SAXException;

    public void fatalError(SAXParseException exception) throws SAXException;

    public void setDocumentLocator(Locator locator);

    public void startDocument() throws SAXException;

    public void endDocument() throws SAXException;

    public void startPrefixMapping(String prefix, String uri) throws SAXException;

    public void endPrefixMapping(String prefix) throws SAXException;

    public void startElement(String uri, String localName, String qName, Attributes atts) throws SAXException;

    public void endElement(String uri, String localName, String qName) throws SAXException;

    public void characters(char[] ch, int start, int length) throws SAXException;
}
