package org.sanskritlibrary;

public class StateInfo
{
    private int errorNumber = 0;
    private Buffers buffers;
	private StringBuilder result;
    private boolean isBuffered = false;

	public StateInfo(StringBuilder result, boolean isBuffered)
	{
        errorNumber = 0;
		this.result = result;
        this.isBuffered = isBuffered;
	}

    public StringBuilder getResult()
    {
        return result;
    }

    public Buffers getBuffers()
    {
        return buffers;
    }

    public void setBuffers(Buffers buffers)
    {
        this.buffers = buffers;
    }

    public void setOffsetMark()
    {
        result.append("\u0004");
    }

    public void updateResult(String s, boolean clear) throws Exception
    {
        updateResult(clear);        // in case anything has already been accumulated.
        result.append(s);
    }

	public void updateResult(boolean clear) throws Exception
	{
        if (isBuffered)
            result.append(buffers.makeString(clear));
	}

    public void updateBuffer(FSMEntry fe) throws Exception
    {
        if (isBuffered)
            buffers.update(fe);
        else
        {
            if (result == null || fe == null || fe.target == null)
                throw new Exception("Something is rotten in StateInfo.updateBuffer");
            result.append(fe.target);
        }
    }

    public int nextErrorNumber()
    {
        return ++errorNumber;
    }
}
