package org.sanskritlibrary;

import java.io.BufferedWriter;

public class SymbolParser extends Parser
{
    BufferedWriter out;

    public boolean canHandle(RTF2 rtf, int start)
    {
        return true;
    }

    public int parse(RTF2 rtf, int n, ParseState ps) throws Exception
    {
        out = rtf.getOutput();
        if (out != null)
        {
            String s = rtf.getRTF();
            int start = n;
            int end = getGroup(rtf, start+1, ps);
            String field = s.substring(start, end);
            Regex re = new Regex(field, "SYMBOL\\s+(\\d+).+Times_Norman.+\\\\fldrslt([^}]+)");
            if (re.find())
            {
                String charno = re.getGroup(1);
                String controlWords = re.getGroup(2);
               String replacement = String.format("{\\*\\clearState0}%s \\'%s", controlWords, TextFormatter.toHexString(Integer.parseInt(charno)));
//               String replacement = String.format("{\\ltrchr %s \\'%s}", controlWords, TextFormatter.toHexString(Integer.parseInt(charno)));
                out.write(replacement);
            }
            else        // write it out without modification
                out.write(field);

            return end;  // points to character immediately after ending brace
        }
        else
            return n;
    }


    public int getGroup(RTF2 rtf, int start, ParseState ps) throws Exception
	{
        String s = rtf.getRTF();
        return PassThroughParser.skipGroup(s, start);
	}



    // this is called whenever a \fN control word is encounter (outside of a fonttbl group)
    public void handleToken(Token t, ParseState ps, StringBuffer accumulateBuffer) throws Exception
    {
    }

    // this is called whenever a \fN control word is encounter (outside of a fonttbl group)
    public void handleToken(Token t, ParseState ps) throws Exception
    {
    }
}
