package org.sanskritlibrary;

import java.util.ArrayList;
import java.util.Enumeration;
import java.util.Hashtable;

public class TabInfo {
    public String name;
    public ArrayList<Text> texts;
    public String defaultEncoding;
    public String[] legalEncodings;    // encoding shared by all files in tab

    public TabInfo(String name) {
        this.name = name;
        texts = new ArrayList<Text>();
    }

    public void setLegalEncodings(Hashtable<String, Integer> h) {
        legalEncodings = new String[h.size()];
        Enumeration<String> en = h.keys();
        int i = 0;
        while(en.hasMoreElements()) {
            legalEncodings[i++] = en.nextElement();
        }
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(String.format("%s [", name));
        String delim = "";
        for (Text text: texts) {
            if (text.type == Text.Type.TextRef) {
                sb.append(String.format("%s'%s'", delim, text.ref));
            } else {
                sb.append(String.format("%s@%s", delim, text.ref));
            }
            delim = ", ";
        }
        sb.append("]");
        return sb.toString();
    }
}
