package org.sanskritlibrary;

import org.sanskritlibrary.webservice.TransformMap;

public class TranscodingRule {
    public String regexName;
    public String pattern;
    public int groupNumber;

    public String startTag;
    public String endTag;
    public String newStartTag;
    public String newEndTag;

    public  TransformMap tm;

    public TranscodingRule(String startTag, String endTag, String newStartTag, String newEndTag, String gn, TransformMap tm) {
        if (startTag == null && endTag == null && gn == null) {
            System.out.format("Either startTag and endTag must be defined of groupNumber must be defined\n");
        }
        else if (gn != null && (startTag != null || endTag != null)) {
            System.out.println("Both tags and groupNumber cannot be defined. Choose one or the other\n");
        }
        else if ((startTag == null && endTag != null) || (startTag != null && endTag == null)) {
            System.out.println("Both start tag and end tag must be defined\n");
        }

        if (startTag == null) {
            this.startTag = "<?>";
        } else {
            this.startTag = startTag;
        }

        if (endTag == null) {
            this.endTag = "</?>";
        } else {
            this.endTag = endTag;
        }

        if (gn != null) {
            try {
                this.groupNumber = Integer.parseInt(gn);
            } catch (Exception ex) {
                System.out.format("groupNumber attribute must be an integer: %s\n", ex.getMessage());
            }
        } else {
            this.groupNumber = 0;
        }

        this.newStartTag = newStartTag;
        this.newEndTag = newEndTag;
        this.tm = tm;
    }

    public void setRegexp(String name, String pattern) {
        this.regexName = name;
        this.pattern = pattern;
    }
}

