package org.sanskritlibrary.webservice;
import org.sanskritlibrary.Regex;
import java.util.Hashtable;

public class MultipartFormData
{
	private Hashtable<String, String> h =  new Hashtable<String, String>();

	public MultipartFormData(String buf) throws Exception
	{
		boolean ok = true;
		String[] fields = buf.split("\r\n");
		if (fields.length > 0)
		{
			Regex re = new Regex(fields[0], "^-*(.*)$");
			if (re.find())
			{
				StringBuilder value = new StringBuilder();
				String id = re.getGroup(1);
				int i = 1;
				while (ok && i < fields.length)
				{
					String pattern = "^Content-Disposition: form-data; name=\"" + "(.*)\"$";
					re = new Regex(fields[i], pattern);
					if (re.find())
					{
						String name = re.getGroup(1);
						i += 2;  // also skip over blank line
						value.setLength(0);
						String sep = "";
						while (!fields[i].contains(id))
						{
							value.append(sep);
							value.append(fields[i]);
							sep = "\r\n";
							i++;
						}
						h.put(name, value.toString());
						i++;
					}
					else
						ok = false;
				}
			}
		}

		if (!ok)
			throw new Exception("Illegal multipart-form-data");
	}

	public String getParameter(String name)
	{
		return h.get(name);
	}
}
