package org.sanskritlibrary.webservice;
import org.sanskritlibrary.FSM;
import org.sanskritlibrary.ResourceInputStream;
import java.io.InputStream;
import java.util.Hashtable;

public class TransformMapEntry
{
	public String tag;
	public boolean retain;          // normally false, if true then tag that delimits input will also appear in output
	public String source;
	public String target;
    public Hashtable<String, String> params;
	public FSM[] fsm = null;
	public TransformMapEntry(String tag, boolean retain, String source, String target, Hashtable<String, String> params,
			  ResourceInputStream ris, Hashtable<String, FSM[]> fsmh) throws Exception
	{
		this.tag = tag;
		this.retain = retain;
        this.params = params;
		source = source.toLowerCase();
		target = target.toLowerCase();
		this.source = source;
		this.target = target;
		String key = String.format("%s/%s", source, target);
		FSM[] priorFSM = fsmh==null ? null : fsmh.get(key);
		if (priorFSM == null)
		{
			fsm = new FSM[2];
			InputStream[] iss = ris.getInputStreams(source, target);
			int i = 0;
			for (InputStream is : iss)
			{
				if (is != null)
					fsm[i++] = FSM.fromXML(is, source, params);
				else
					throw new Exception(String.format("Could not find file %s_%s.xml.", source, target));
			}
			if (fsmh != null)
				fsmh.put(key, fsm);
		}
		else
			fsm = priorFSM;
	}
}
